
#property copyright "Tradefxp.com"
#property link      "Tradefxp.com"
#property version   "2.45"
#property description " Price Channel EA  "



// Global Enum
enum StopLossType {    No_Stoploss,    Fixed_Stoploss,  Prev_No_Bars, Channel_Stop };
enum SignalType {    TrendSignal,    ReversSignal,  Both, };

// Inputs

extern string           oooooooo            = " ---  Main Indicator Settings --- "; 

extern double   Lots                        = 0.01;
extern int      Slippage                    = 30;
extern string   Indiactor_file              = "pricechannel_stop_v1.3";
extern ENUM_TIMEFRAMES Indicator_Period     = 0;
extern double   ChannelPeriod               = 21;   
extern double   Risk                        = 0.3;  
extern int      MaxTrade                    = 10;
 int   Grid_Gap                       = 0;

extern string           xxxxxxxxxx          = " ---  Stoploss & TP Settings --- "; 
extern StopLossType     Stoploss            = No_Stoploss;
extern int      StopLoss_pip                = 200;
extern int      StopLoss_Bars               = 5;
extern bool     UseProfitTrail              = True;
extern int      TrailingStop                = 200;

extern bool     UseTakeProfit               = False;
extern int      TakeProfit                  = 100;


 int      Magic_D                = 112358;
 int      Magic_UP               = 1123581; 


extern string  oooooooooo                   = " ---  2nd Indicator Settings --- "; 
extern bool     Active_EA2                  = True;
extern ENUM_TIMEFRAMES Indicator_Period2    = 0;
extern double   ChannelPeriod2              = 9;
extern SignalType     EASignalType          = TrendSignal;

//extern bool     UseTakeProfit_2nd           = False;
//extern bool     UseStopLoss_2nd             = False;


extern string  oooooo                       = " ---  Time Filter --- "; // Add this Two lines top 
extern bool     Time_Filter                 = False;
extern string    start_Time                 = "00:00";
extern string    end_Time                   = "23:59";

extern bool     Order_close_Revers_signal   = True;

int             timeAllowed = 1;

// Inputs -------


//  global varibale 

double DownTrendSignal_line, UpTrendSignal_line, UpTrendSignal_line01, UpTrendSignal_line02, DownTrendSignal_line01, DownTrendSignal_line02,DownTrendSignal_Signal,UpTrendSignal_Signal;


double BuyStoploss, buytake, buystop, selltake, sellstop, Nextbuyprice, Nextsellprice,points,Lactaction;

int buyrevers, sellrevers, totalorders,SymbOrdTot;

static datetime LastActionTime = 0;



void OnTick() 


{
   
   
  
   // Indicator inputs 
    UpTrendSignal_line      = iCustom(Symbol(),Indicator_Period,Indiactor_file,ChannelPeriod,Risk,0,1);
    DownTrendSignal_line    = iCustom(Symbol(),Indicator_Period,Indiactor_file,ChannelPeriod,Risk,1,1);
    
    UpTrendSignal_Signal      = iCustom(Symbol(),Indicator_Period,Indiactor_file,ChannelPeriod,Risk,2,1);
    DownTrendSignal_Signal    = iCustom(Symbol(),Indicator_Period,Indiactor_file,ChannelPeriod,Risk,3,1);
    
    UpTrendSignal_line01    = iCustom(Symbol(),Indicator_Period2,Indiactor_file,ChannelPeriod2,Risk,2,1);
    DownTrendSignal_line01  = iCustom(Symbol(),Indicator_Period2,Indiactor_file,ChannelPeriod2,Risk,3,1);
    
    UpTrendSignal_line02    = iCustom(Symbol(),Indicator_Period2,Indiactor_file,ChannelPeriod2,Risk,2,2);
    DownTrendSignal_line02  = iCustom(Symbol(),Indicator_Period2,Indiactor_file,ChannelPeriod2,Risk,3,2);
   
   

   
   // Time Filter 
   if ( Time_Filter == true ) {
   
      if ( TimeCurrent() >= StringToTime( start_Time ) && TimeCurrent () < StringToTime ( end_Time ) )
         {
            timeAllowed           =  1;
            Comment("Time Allowed");         
         } 
      else
         { 
            timeAllowed           =  2; 
            Comment(" EA Not Allowed to trade this Time, Please reffer Time Filter Settings "); 
           }
        } 
        else    { timeAllowed           =  1; }
   // Time Filter  -----
   
   int sec = TimeSeconds(TimeCurrent());
   totalorders = OrdersTotal();
   
   
   //if ( Digits >= 3 ) {  points = Point *10; } else { points = Point; }
   
   points = Point *10;
   
   // Checking orders by symbol
   SymbOrdTot  =  0;
   for (int OrdersCount = 0; OrdersCount < OrdersTotal(); OrdersCount ++) 
   {
      OrderSelect(OrdersCount, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() ) 
      {
         SymbOrdTot = SymbOrdTot + 1;  
         //SymbOrdTicket = OrderTicket();        
      }
   }
     
   
   
   // -- Reversal Block 
   if ( Order_close_Revers_signal == True ) // == 1 SymbOrdTot  > 0 &&
   //Comment("Reversal Working");
    
   {     // Closing Buy Order   
         if ( (UpTrendSignal_line > 5000) ) //|| (UpTrendSignal0 == -1.0000  && UpTrendSignal1 > 1.0000) 
         {  //Comment("\n","\n","Close Buy ", UpTrendSignal_Signal);
           //int count       = OrdersTotal();
           
           for ( int i = OrdersTotal() -1; i >= 0; i-- ) {
           
                if ( OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
                    if ( OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_UP ) { //&& OrderMagicNumber() == inpMagicNumber && OrderType() == OP_SELL
                         
                         int orderclose1 = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),0 );
                         if ( orderclose1 > 1) { Print( " Orders Not close", GetLastError()  );}
                         }
                    }
            }
            
            Nextbuyprice = 0;
        } 
        // --- Closing Buy Order 
        
        
        // Closing Sell Order 
        if ( (UpTrendSignal_line < 5000) ) //|| (UpTrendSignal0 == -1.0000  && UpTrendSignal1 > 1.0000) 
         {  //Comment("\n","\n","Close Sell ", UpTrendSignal_Signal);
           //int countX       = OrdersTotal();
          
           for ( int X = OrdersTotal() -1; X >= 0; X-- ) {
           
                if ( OrderSelect(X, SELECT_BY_POS, MODE_TRADES)) { 
                    if ( OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_D ) { //&& OrderMagicNumber() == inpMagicNumber && OrderType() == OP_SELL
                         
                         int orderclose = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),0 );
                         if ( orderclose > 1) { Print( " Orders Not close", GetLastError()  );}
                         }
                    }
            }
            
            Nextsellprice = 0;
        }
       // ----- Closing Sell Order 
    }
   // -- Reversal Block 
   
  // Order Block 
   if (  timeAllowed  ==  1 )      {    
        
        Comment("\n","Status: ", (UpTrendSignal_line < 5000 )?"UP Trend " :"Down Trend", "\n" );
        
             
        
        
        
        
       // ---------------   Buy Trade Blocks ------------------ 
        if (UpTrendSignal_line < 5000 ) // Uptrend :: Buy && OrdersTotal() == 0 
     
           { 
              if (AccountFreeMargin() < (1000 * Lots))  { Print("Not Enough Money. Free Margin = ", AccountFreeMargin()); }               
                              
               // Stoploss cal by type
               double StopLossLevel;
               switch ( Stoploss ) { 
               
                    case No_Stoploss        : StopLossLevel = 0;    break;
                    case Fixed_Stoploss     : StopLossLevel = Ask - ( StopLoss_pip * points );     break;
                    case Prev_No_Bars       : StopLossLevel = Low[iLowest(_Symbol,Indicator_Period,MODE_LOW,StopLoss_Bars,1)];     break;    
                    case Channel_Stop       : StopLossLevel = UpTrendSignal_line;     break;   
                              
               }
               
               // Stoploss ------------
              double MinStop = Ask - (MarketInfo(_Symbol,MODE_STOPLEVEL)* points);

              if (UseTakeProfit) double TakeProfitLevel = Ask + TakeProfit * points; else TakeProfitLevel = 0.0;
            //Comment(StopLossLevel);
              if (UpTrendSignal_line < 5000 && UpTrendSignal_Signal < 5000 && (Lactaction != iOpen(Symbol(),Indicator_Period,0)) ) {
                  Lactaction = iOpen(Symbol(),Indicator_Period,0);
                  //LastAction = UpTrendSignal_line;
                  bool Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage,( StopLossLevel < MinStop )?StopLossLevel:MinStop, TakeProfitLevel, " TopGear" + " | " + Indicator_Period  , Magic_UP, 0, Green);
                  if(Ticket) {    
                        if ( OrderSelect( Ticket, SELECT_BY_TICKET ) ) {
                   
                            Print("EA1, Buy Order Opened : ", OrderOpenPrice());
                            Print("Total Order Opened : ", OrdersTotal());
                            //buytake = OrderTakeProfit();
                            //buystop = OrderStopLoss();
                        }
                          
        		    	   
                   }else  {  Print("Error Opening Buy Order : ", GetLastError());   }
                   
                   Nextbuyprice = Ask + Grid_Gap * points;
                   
               }
               
               //Sleep(6000*Indicator_Period); // 1 Min pass  
             // Revers Signal  && EA2
             double currentAsk = MarketInfo(Symbol(), MODE_ASK);
             if ( Active_EA2 == True && (LastActionTime != Time[0]) ) {
                if ( EASignalType == TrendSignal ||  EASignalType == Both ) {  if ( UpTrendSignal_line01 < 5000 && UpTrendSignal_line02 > 5000  && SymbOrdTot < MaxTrade  /* && (Ask >= Nextbuyprice ) */ ) {  //  in 1 sec
                    LastActionTime = Time[0];
                    Nextbuyprice = Ask + Grid_Gap * points;
                    int ticket = OrderSend(_Symbol, OP_BUY, Lots, Ask, Slippage, StopLossLevel , TakeProfitLevel , " TopGear 2" + " | " + Indicator_Period2, Magic_UP, 0, Green);
                    if ( ticket > 0 ) {   if ( OrderSelect( ticket, SELECT_BY_TICKET ) ) { Print(" EA2, Buy Order Opened : ", OrderOpenPrice());}  }    else { Print("Error Opening EA2 Buy Order : ", GetLastError()); }
                    
                
                 }  }
                
                
                if ( EASignalType == ReversSignal ||  EASignalType == Both  ) {  if ( DownTrendSignal_line01 < 5000 && DownTrendSignal_line02 > 5000  && SymbOrdTot < MaxTrade  /* && (Ask >= Nextbuyprice )*/) { 
                        LastActionTime = Time[0];
                        Nextbuyprice = Ask + Grid_Gap * points;
                        int ticket01 = OrderSend(_Symbol, OP_BUY, Lots, Ask, Slippage, StopLossLevel , TakeProfitLevel , " TopGear 2" + " | " + Indicator_Period2, Magic_UP, 0, Green);
                        if ( ticket01 > 0 ) { if ( OrderSelect( ticket01, SELECT_BY_TICKET ) ) { Print(" EA2, Buy Order Opened : ", OrderOpenPrice() );}  } else { Print("Error Opening EA2 Buy Order : ", GetLastError()); }
                        
                 }  }
                
               
             }            
             // Revers Signal -------
           
        
         
           }
        // ---------------   Buy Trade Blocks ------------------  
        
        
        // +---------------   Sell Trade Blocks ------------------+
        if (DownTrendSignal_line < 5000 ) // Uptrend :: Buy && OrdersTotal() == 0 
     
           { 
              if (AccountFreeMargin() < (1000 * Lots))  { Print("Not Enough Money. Free Margin = ", AccountFreeMargin()); }               
                
                double checkminstop = Bid + MarketInfo(_Symbol,MODE_STOPLEVEL);
                              
               // Stoploss cal by type
               double SellStopLossLevel;
               switch ( Stoploss ) {
               
                    case No_Stoploss        : SellStopLossLevel = 0;    break;
                    case Fixed_Stoploss     : SellStopLossLevel = Bid + StopLoss_pip * points;     break;
                    case Prev_No_Bars       : SellStopLossLevel = High[iHighest(_Symbol,Indicator_Period,MODE_HIGH,StopLoss_Bars,1)];     break;        
                    case Channel_Stop       : SellStopLossLevel = DownTrendSignal_line;     break;
                              
               }
               
               // Stoploss ------------

              if (UseTakeProfit) double sellTakeProfitLevel = Bid - TakeProfit * points; else TakeProfitLevel = 0.0;
            //Comment(StopLossLevel);
              if (DownTrendSignal_line < 5000 && DownTrendSignal_Signal < 5000 && (Lactaction != iOpen(Symbol(),Indicator_Period,0))) {
                  Lactaction = iOpen(Symbol(),Indicator_Period,0);
                  //LastAction = DownTrendSignal_line;
                  bool Ticket1 = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, SellStopLossLevel, sellTakeProfitLevel," TopGear" + " | " + Indicator_Period, Magic_D, 0, Red);
                  if(Ticket1) {
                        if ( OrderSelect( Ticket1, SELECT_BY_TICKET ) ) { 
                            Print("EA1, Sell Order Opened : ", OrderOpenPrice());
                            Print("Total Order Opened : ", OrdersTotal());
                            //selltake = OrderTakeProfit();
                            //sellstop = OrderStopLoss();
                         }
                      
                   }else  {  Print("Error Opening Sell Order : ", GetLastError());     }
                   
                   Nextsellprice = Bid - Grid_Gap * points;
                             
                   
               }
               
             // Sleep(6000*Indicator_Period); // 1 Min pass  
             double MinStopB = Bid - (MarketInfo(_Symbol,MODE_STOPLEVEL)* points);
             
             if ( Active_EA2 == True && (LastActionTime != Time[0]) ) {
                 if ( ( EASignalType == TrendSignal ||  EASignalType == Both ) && DownTrendSignal_line01 < 5000 && DownTrendSignal_line02 > 5000  && SymbOrdTot < MaxTrade  /* && (Bid <= Nextsellprice )*/ ) {
                        LastActionTime = Time[0];
                        Nextsellprice = Bid - Grid_Gap * points;                                      
                        int ticket1 = OrderSend(_Symbol, OP_SELL, Lots, Bid, Slippage, ( SellStopLossLevel < MinStopB)?SellStopLossLevel:MinStopB , sellTakeProfitLevel ,  " TopGear 2" + " | " + Indicator_Period2, Magic_D, 0, Red);
                        if ( ticket1 > 0 ) { if ( OrderSelect( ticket1, SELECT_BY_TICKET ) ) {  Print(" EA2, Sell Order Opened : ", OrderOpenPrice() );} }  else { Print("Error Opening EA2 Sell Order : ", GetLastError()); }
                        
                        //Sleep(Indicator_Period2*6000);
                  }
                  
                  if ( ( EASignalType == ReversSignal ||  EASignalType == Both ) && UpTrendSignal_line01 < 5000 && UpTrendSignal_line02 > 5000    && SymbOrdTot < MaxTrade  /* && (Bid <= Nextsellprice ) */ ) {
                        LastActionTime = Time[0];
                        Nextsellprice = Bid - Grid_Gap * points;                                     
                        int ticket02 = OrderSend(_Symbol, OP_SELL, Lots, Bid, Slippage, SellStopLossLevel, sellTakeProfitLevel , " TopGear 2" + " | " + Indicator_Period2, Magic_D, 0, Red);
                        if ( ticket02 > 0 ) { if ( OrderSelect( ticket02, SELECT_BY_TICKET ) ) {  Print(" EA2, Sell Order Opened : ", OrderOpenPrice() );} } else { Print("Error Opening EA2 Sell Order : ", GetLastError()); }
                        
                        //Sleep(Indicator_Period2*6000);
                  }
                 
             }
             // Revers Signal  && EA2-----------     
         
           }
        // +---------------   Sell Trade Blocks ------------------+               
            
       }   /// Orders Block --------   
       
   // Trailing Stoploss -*-------------- 
   
   if ( UseProfitTrail == True  ) {
        
        
        // Checking Orders & counting 
        for ( int T= totalorders-1; T >= 0; T--){
            //Comment("TrailingStop");
            // selecting order
            if ( OrderSelect(T,SELECT_BY_POS  ) ) {
            // if we have Buy Orders
                if ( OrderSymbol()==_Symbol && OrderType() == OP_BUY ){
                    //Comment("\n","\n","TrailingStop:: Buy");
                    // checking stoploss is below trailing stop
                   // if ( OrderOpenPrice() > OrderOpenPrice() + ( TrailingStop * points ) ) {
                        if ( OrderStopLoss() < Ask - ( TrailingStop * points ) ){
                        
                            // Modify Order
                            bool Bmodify = OrderModify(OrderTicket(),OrderOpenPrice(), Ask - ( TrailingStop * points ), OrderTakeProfit(), 0 , clrNONE );
                            if(!Bmodify) printf("Error in Buy OrderModify. Error Code: ", GetLastError()); else printf(" Buy OrderModified ");
                         }
                   // }
                }
                
                // Checking sell
                if ( OrderSymbol() == _Symbol && OrderType() == OP_SELL ) { 
                    
                    // Checking stoploss distance
                   // if ( OrderOpenPrice() < OrderOpenPrice() - ( TrailingStop * points) ) {
                        if ( OrderStopLoss() > Bid + ( TrailingStop * points) ) {
                            //Comment("\n","TrailingStop:: Sell");
                            //Modify
                            bool modify = OrderModify(OrderTicket(), OrderOpenPrice(), Bid + ( TrailingStop * points), OrderTakeProfit(),0, clrNONE );
                            if(!modify) printf("Error in Sell OrderModify. Error Code: ", GetLastError()); else printf(" Sell OrderModified ");
                         }
                   // }
                } 
            }
        }
   
   
   }
   
   // Trailing Stoploss -*--------------       
  
   
   
   
   

} // Start Ends ---------------
//////////////////////////////////////////////////////////////////////////////////////////



